<?php echo $header; ?>

<ul class="breadcrumb">
    <li><a href="<?php echo site_url('admin'); ?>"><?php echo lang('header_tab_configure'); ?></a> <span class="divider">/</span></li>
    <li><a href="<?php echo site_url('admin/users'); ?>"><?php echo lang('breadcrumb_users'); ?></a> <span class="divider">/</span></li>
    <li class="active"><?php echo lang('breadcrumb_create_user'); ?></li>
</ul>

<div class="container">
    <div class="row-fluid">
        <div class="span12 configure-layout">
            <?php echo $leftbar; ?>
            <div class="rside">
                <h2><?php echo lang('create_user_heading');?></h2>
                <p><?php echo lang('create_user_subheading');?></p>
                <?php if (!empty($error)) { ?><div class="alert alert-error"><?php echo $error; ?></div><?php } ?>

                <?php echo form_open(current_url());?>
                <div class="row-fluid">
                    <div class="span6">
                        <h4><?php echo lang('create_user_details_heading'); ?></h4>
                        <table>
                            <tr>
                                <td class="form-left" style="width: 140px;"><?php echo lang('create_user_name'); ?>:</td>
                                <td>
                                    <input type="text" name="first_name" value="<?php echo set_value('first_name'); ?>" class="input-medium"> 
                                    <input type="text" name="last_name" value="<?php echo set_value('last_name'); ?>" class="input-medium">
                                </td>
                            </tr>
                            <tr>
                                <td class="form-left"><?php echo lang('create_user_company'); ?>:</td>
                                <td><input type="text" name="company" value="<?php echo set_value('company'); ?>" class="input-xlarge"></td>
                            </tr>
                            <tr>
                                <td class="form-left"><?php echo lang('create_user_email'); ?>:</td>
                                <td><input type="text" name="email" value="<?php echo set_value('email'); ?>" class="input-xlarge"> *</td>
                            </tr>
                            <tr>
                                <td class="form-left"><?php echo lang('create_user_phone'); ?>:</td>
                                <td><input type="text" name="phone" value="<?php echo set_value('phone'); ?>" class="input-small" maxlength="10"></td>
                            </tr>
                        </table>
                        <h4><?php echo lang('create_user_account_heading'); ?></h4>
                        <table>
                            <tr>
                                <td class="form-left" style="width: 140px;"><?php echo lang('create_user_username'); ?>:</td>
                                <td><input type="text" name="username" value="<?php echo set_value('username'); ?>" class="input"> *</td>
                            </tr>
                            <tr>
                                <td class="form-left"><?php echo lang('create_user_password'); ?>:</td>
                                <td><input type="password" name="password" value="<?php echo set_value('password'); ?>" class="input-medium"> *</td>
                            </tr>
                            <tr>
                                <td class="form-left"><?php echo lang('create_user_conf_password'); ?>:</td>
                                <td><input type="password" name="password2" value="<?php echo set_value('password2'); ?>" class="input-medium"> *</td>
                            </tr>
                            <tr>
                                <td class="form-left"><?php echo lang('language'); ?>:</td>
                                <td>
                                    <select name="language" class="input-medium">
                                        <option value="default" <?php if (set_value('language') == 'default') { echo 'selected'; } ?>><?php echo lang('default'); ?></option>
                                        <?php foreach ($languages as $l) { ?>
                                        <option value="<?php echo $l; ?>" <?php if (set_value('language') == $l) { echo 'selected'; } ?>>
                                            <?php $output = lang('language_' . $l); if (empty($output)) { echo uppercase($l); } else { echo $output; } ?>
                                        </option>
                                        <?php } ?>
                                    </select>
                                </td>
                            </tr>
                        </table>
                    </div>
                    <div class="span6">
                        <h4><?php echo lang('create_user_al_title'); ?></h4>
                        <p><?php echo lang('create_user_al_desc'); ?></p>
                        <label class="radio"><input type="radio" name="group" value="1" <?php if ($admin_checked) { echo "checked"; } ?>> <strong><?php echo lang('create_user_al_admin'); ?></strong> - <?php echo lang('create_user_al_admin_desc'); ?></label>
                        <label class="radio"><input type="radio" name="group" value="2" <?php if ($user_checked) { echo "checked"; } ?>> <strong><?php echo lang('create_user_al_user'); ?></strong> - <?php echo lang('create_user_al_user_desc'); ?></label>
                        <h4><?php echo lang('create_user_api_title'); ?></h4>
                        <p><?php echo lang('create_user_api_desc'); ?></p>
                        <label class="radio">
                            <input type="radio" name="apiaccess" value="1" <?php if (set_value('apiaccess') == 1) { echo "checked"; } ?>> <?php echo lang('yes_button'); ?>
                        </label>
                        <label class="radio">
                            <input type="radio" name="apiaccess" value="0" <?php if (!set_value('apiaccess')) { echo "checked"; } ?>> <?php echo lang('no_button'); ?>
                        </label>
                    </div>
                </div>
                <div class="row-fluid">
                    <div class="span12">
                        <div style="margin-top: 15px; margin-bottom: 0;" class="form-actions">
                            <button type="submit" class="btn btn-primary"><?php echo lang('create_user_submit_btn'); ?></button>
                            <a href="<?php echo site_url('admin/users'); ?>" class="btn"><?php echo lang('cancel_button'); ?></a>
                        </div>
                    </div>
                </div>
                <?php echo form_close();?>
            </div>
        </div>
    </div>
</div>


<?php echo $footer; ?>